     //////////////////////////////////////////////////////////////////////
     // Copyright (c) 1997 Analytic Services, Inc. (ANSER)
     // Copyright (c) 1999 David Wallace Croft (croft@alumni.caltech.edu)
     //
     // Permission is hereby granted, free of charge, to any person
     // obtaining a copy of this software and associated documentation
     // files (the "Software"), to deal in the Software without
     // restriction, including without limitation the rights to use, copy,
     // modify, merge, publish, distribute, sublicense, and/or sell copies
     // of the Software, and to permit persons to whom the Software is
     // furnished to do so, subject to the following conditions:
     //
     // The above copyright notice and this permission notice shall be
     // included in all copies or substantial portions of the Software.
     //
     // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
     // EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
     // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
     // NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
     // HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
     // WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
     // OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
     // DEALINGS IN THE SOFTWARE.
     //
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mit.app.hitcounter;

     import java.awt.*;
     import java.awt.image.*;

     /*********************************************************************
     * <P>
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   1998-12-24
     *********************************************************************/

     public class  PixelCount extends Frame {
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     private Image     image;
     private Graphics  g;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public static final void  main ( String [ ]  args ) {
     //////////////////////////////////////////////////////////////////////
       new PixelCount ( );
     }

     public  PixelCount ( )
     //////////////////////////////////////////////////////////////////////
     {
       super ( "PixelCount" );
       setBounds ( 0, 0, 160, 60 );
       show ( );
       image = createImage ( 110, 12 );
     }

     public void  paint ( Graphics  graphics ) {
     //////////////////////////////////////////////////////////////////////
       if ( g == null ) g = image.getGraphics ( );
       g.setColor ( Color.black );
       g.fillRect ( 0, 0, 110, 12 );
       g.setFont ( new Font ( "Courier", Font.BOLD, 18 ) );
       g.setColor ( Color.white );
       String  s = "0123456789";
       g.drawString ( s, 0, 12 );
       int  w = g.getFontMetrics ( ).stringWidth ( s );
//     System.out.println ( w );
       int  h = g.getFontMetrics ( ).getAscent ( );
//     System.out.println ( h );
       Insets  insets = getInsets ( );
       graphics.drawImage ( image, insets.left, insets.top, this );
       int [ ]  pixels = new int [ ( w / 10 ) * h ];

       for ( int  i = 0; i < 10; i++ ) {
         PixelGrabber  pg = new PixelGrabber (
           image, i * w / 10, 0, w / 10, h, pixels, 0, w / 10 );
         try { pg.grabPixels ( ); } catch ( InterruptedException  e ) { }
         System.out.print ( "     public static final int [ ] [ ]  " );
         String  ns;
         switch ( i ) {
           case 0:  ns = "ZERO" ; break;
           case 1:  ns = "ONE"  ; break;
           case 2:  ns = "TWO"  ; break;
           case 3:  ns = "THREE"; break;
           case 4:  ns = "FOUR" ; break;
           case 5:  ns = "FIVE" ; break;
           case 6:  ns = "SIX"  ; break;
           case 7:  ns = "SEVEN"; break;
           case 8:  ns = "EIGHT"; break;
           case 9:  ns = "NINE" ; break;
           default:  ns = null;
         }
         System.out.println ( ns + " = { " );
         for ( int  y = 0; y < 12; y++ ) {
           System.out.print ( "       { " );
           for ( int  x = 0; x < 11; x++ ) {
             int  p = pixels [ y * 11 + x ];
             p = p & 0x00FFFFFF;
             System.out.print ( "0x" + pad (
               Integer.toHexString ( p ).toUpperCase ( ), 6, '0' ) );
             System.out.print ( ( x == 10 ) ? " }" : ", " );
           }
           System.out.println ( ( y == 11 ) ? " };" : "," );
         }
         System.out.println ( "" );
       }

     }

     public static String  pad ( String  s, int  len, char  c ) {
     //////////////////////////////////////////////////////////////////////
       String  padded = new String ( s );
       while ( padded.length ( ) < len ) padded = c + padded;
       return padded;
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
