     //////////////////////////////////////////////////////////////////////
     //
     // Copyright (C) 1998 Analytic Services, Inc. (ANSER)
     //
     // Permission is hereby granted, free of charge, to any person
     // obtaining a copy of this software and associated documentation
     // files (the "Software"), to deal in the Software without
     // restriction, including without limitation the rights to use, copy,
     // modify, merge, publish, distribute, sublicense, and/or sell copies
     // of the Software, and to permit persons to whom the Software is
     // furnished to do so, subject to the following conditions:
     //
     // The above copyright notice and this permission notice shall be
     // included in all copies or substantial portions of the Software.
     //
     // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
     // EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
     // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
     // NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
     // HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
     // WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
     // OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
     // DEALINGS IN THE SOFTWARE.
     //
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mit.servlet;

     import java.io.Serializable;
     import java.util.Date;

     /*********************************************************************
     * <P>
     * @author                                                        
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   1997-10-26
     *********************************************************************/

     public abstract class  Mission implements Runnable, Serializable {
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     private transient AgentServlet  agentServlet;
     private           Date          lastRun;
     private           Date          nextRun;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     //////////////////////////////////////////////////////////////////////
     // Abstract Methods
     //////////////////////////////////////////////////////////////////////

     public abstract void  run ( );

     //////////////////////////////////////////////////////////////////////
     // Access Methods
     //////////////////////////////////////////////////////////////////////

     public AgentServlet  getAgentServlet ( ) {
       return agentServlet; }
     public void  setAgentServlet ( AgentServlet  agentServlet ) {
       this.agentServlet = agentServlet; }

     public Date  getLastRun ( ) {
       return lastRun; }
     public void  setLastRun ( Date  lastRun ) {
       this.lastRun = lastRun; }

     public Date  getNextRun ( ) {
       return nextRun; }
     public void  setNextRun ( Date  nextRun ) {
       this.nextRun = nextRun; }

     //////////////////////////////////////////////////////////////////////
     // Convenience Methods
     //////////////////////////////////////////////////////////////////////

     public boolean  isRunDue ( ) {
     //////////////////////////////////////////////////////////////////////
       Date  nextRun = getNextRun ( );
       if ( nextRun == null ) return false;
       return !( new Date ( ) ).before ( nextRun );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
