     //////////////////////////////////////////////////////////////////////
     //
     // Copyright (C) 1998 Analytic Services, Inc. (ANSER)
     //
     // Permission is hereby granted, free of charge, to any person
     // obtaining a copy of this software and associated documentation
     // files (the "Software"), to deal in the Software without
     // restriction, including without limitation the rights to use, copy,
     // modify, merge, publish, distribute, sublicense, and/or sell copies
     // of the Software, and to permit persons to whom the Software is
     // furnished to do so, subject to the following conditions:
     //
     // The above copyright notice and this permission notice shall be
     // included in all copies or substantial portions of the Software.
     //
     // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
     // EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
     // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
     // NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
     // HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
     // WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
     // OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
     // DEALINGS IN THE SOFTWARE.
     //
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mit.servlet;

     import java.util.*;

     import javax.servlet.*;

     import com.orbs.open1.mit.util.param.*;

     /*********************************************************************
     *
     * A library of static methods to support Servlet operations.
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     * @version
     *   2000-04-12
     *********************************************************************/

     public final class  ServletLib
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private  ServletLib ( ) { }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     /*********************************************************************
     * Extracts the servlet parameters and stores them in a Parameters
     * container.
     *********************************************************************/
     public static Parameters  extractParameters (
       ServletRequest  servletRequest )
     //////////////////////////////////////////////////////////////////////
     // See javax.servlet.http.HttpUtils if updating.
     //////////////////////////////////////////////////////////////////////
     {
       Parameters  parameters = new ParametersHashtable ( );

       Enumeration  e = servletRequest.getParameterNames ( );

       while ( e.hasMoreElements ( ) )
       {
         String  name = ( String ) e.nextElement ( );

         String [ ]  values = servletRequest.getParameterValues ( name );

         parameters.setValues ( name, values );
       }

       return parameters;
     }

     /*********************************************************************
     * Returns the first value for a given field name.
     * Returns null if no values are available.
     * <P>
     * A substitute for the deprecated
     *   HttpServletRequest.getParameter ( String  name ) method.
     *********************************************************************/
     public static String  getParameter (
       ServletRequest  req, String  fieldName )
     //////////////////////////////////////////////////////////////////////
     {
       String [ ]  values = req.getParameterValues ( fieldName );
       if ( values == null ) return null;
       return values [ 0 ];
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
