     //////////////////////////////////////////////////////////////////////
     //
     // Copyright (C) 1998 Analytic Services, Inc. (ANSER)
     //
     // Permission is hereby granted, free of charge, to any person
     // obtaining a copy of this software and associated documentation
     // files (the "Software"), to deal in the Software without
     // restriction, including without limitation the rights to use, copy,
     // modify, merge, publish, distribute, sublicense, and/or sell copies
     // of the Software, and to permit persons to whom the Software is
     // furnished to do so, subject to the following conditions:
     //
     // The above copyright notice and this permission notice shall be
     // included in all copies or substantial portions of the Software.
     //
     // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
     // EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
     // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
     // NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
     // HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
     // WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
     // OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
     // DEALINGS IN THE SOFTWARE.
     //
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mit.util;

     import java.io.*;
     import java.util.*;

     /*********************************************************************
     * Ch. 8 "Sorting" of <I>Numerical Recipes:  The Art of Scientific
     * Computing</I> by Press, et al has the good stuff.  Unfortunately,
     * I wasn't reading that chapter when I wrote this.  Rewrite this
     * class, please!
     * <P>
     * @author                                                        
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   1997-10-06
     *********************************************************************/

     public class  Sort {
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     /*********************************************************************
     * Vanderburg, Glenn; <I>Tricks of the Java Programming Gurus</I>,
     *   Chapter 9, "Extending AWT Components", "Sorting the Strings",
     *   p162; 1996.  This is an N-squared sorting algorithm.  Bad!
     *********************************************************************/
     public static void  bubble ( String [ ]  strings ) {
     //////////////////////////////////////////////////////////////////////
       for ( int  i = 0; i < strings.length - 1; i++ ) {
         boolean  swaps = false;
         for ( int  j = strings.length - 2; j >= i; j-- ) {
           if ( strings [ j ].compareTo ( strings [ j + 1 ] ) > 0 ) {
             String  temp      = strings [ j ];
             strings [ j ]     = strings [ j + 1 ];
             strings [ j + 1 ] = temp;
             swaps = true;
           }
         }
         if ( !swaps ) break;
       }
     }
        
     /*********************************************************************
     * Finds the appropriate index for a record which is about to be
     * inserted into a sorted list.  Uses binary search.  Assumes that the
     * highest value should be at index position 0.  I just whipped
     * this out without referencing any source so I don't know
     * if this works efficiently or even reliably.
     *********************************************************************/
     public static int  rank ( double  value, double [ ]  sorted ) {
     //////////////////////////////////////////////////////////////////////
       if ( sorted == null ) return 0;
       int  bot = sorted.length - 1;
       if ( bot == -1 ) return 0;
       int  top = 0;
       while ( top < bot ) {
         int  mid = top + ( bot - top ) / 2;
         if ( value > sorted [ mid ] ) bot = mid; else top = mid + 1;
       }
       return top;
     }
        
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
