     //////////////////////////////////////////////////////////////////////
     //
     // Copyright (C) 1998 Analytic Services, Inc. (ANSER)
     //
     // Permission is hereby granted, free of charge, to any person
     // obtaining a copy of this software and associated documentation
     // files (the "Software"), to deal in the Software without
     // restriction, including without limitation the rights to use, copy,
     // modify, merge, publish, distribute, sublicense, and/or sell copies
     // of the Software, and to permit persons to whom the Software is
     // furnished to do so, subject to the following conditions:
     //
     // The above copyright notice and this permission notice shall be
     // included in all copies or substantial portions of the Software.
     //
     // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
     // EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
     // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
     // NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
     // HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
     // WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
     // OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
     // DEALINGS IN THE SOFTWARE.
     //
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mit.util.param;

     import java.util.Hashtable;

     /*********************************************************************
     *
     * A Hashtable that implements the Parameters interface.
     *
     * <P>
     *
     * This is a white-box implementation of Parameters;
     * contrast with MappedParameters.
     *
     * <P>
     *
     * @see
     *   Parameters
     * @see
     *   ParametersLib
     * @see
     *   MappedParameters
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     * @version
     *   2000-04-10
     *********************************************************************/

     public class  ParametersHashtable
       extends Hashtable implements Parameters
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     public boolean  addName ( String  parameterName )
     //////////////////////////////////////////////////////////////////////
     {
       return ParametersLib.addName ( this, parameterName );
     }

     public String  getFirstValue ( String  parameterName )
     //////////////////////////////////////////////////////////////////////
     {
       return ParametersLib.getFirstValue ( this, parameterName );
     }

     public String  getFirstValue (
       String  parameterName, String  defaultValue )
     //////////////////////////////////////////////////////////////////////
     {
       return ParametersLib.getFirstValue (
         this, parameterName, defaultValue );
     }

     public String [ ]  getNames ( )
     //////////////////////////////////////////////////////////////////////
     {
       return ParametersLib.getNames ( this );
     }

     public String [ ]  getValues ( String  parameterName )
     //////////////////////////////////////////////////////////////////////
     {
       return ParametersLib.getValues ( this, parameterName );
     }

     public String [ ]  removeName ( String  parameterName )
     //////////////////////////////////////////////////////////////////////
     {
       return ParametersLib.removeName ( this, parameterName );
     }

     public String [ ]  setValues (
       String  parameterName, String [ ]  parameterValues )
     //////////////////////////////////////////////////////////////////////
     {
       return ParametersLib.setValues (
         this, parameterName, parameterValues );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
