     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is
     // "com.orbs.open1.mpl.app.chat.client.reactor.ChatReactorLoad",
     // created 2000-01-16.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 2000 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.app.chat.client.reactor;

     import com.orbs.open1.mpl.app.chat.*;
     import com.orbs.open1.mpl.app.chat.client.*;

     /*********************************************************************
     * <P>
     *
     * @version
     *   2000-01-23
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     *********************************************************************/

     public final class  ChatReactorLoad implements ChatReactor
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private final ChatClient  chatClient;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public  ChatReactorLoad ( ChatClient  chatClient )
     //////////////////////////////////////////////////////////////////////
     {
       this.chatClient = chatClient;
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public ChatMessage [ ]  react ( ChatMessage  chatMessage )
     //////////////////////////////////////////////////////////////////////
     {
       String [ ]  values = chatMessage.getValues ( );

       for ( int  i = 0; i < values.length; i += 4 )
       {
         ChatThingID  chatThingID = new ChatThingID ( values [ i ] );

         String  avatar_image_pathfilename = values [ i + 1 ];

         int     x = Integer.parseInt ( values [ i + 2 ] );

         int     y = Integer.parseInt ( values [ i + 3 ] );

         chatClient.createChatThing (
           chatThingID, avatar_image_pathfilename, x, y );
       }

       chatClient.display ( "Received environment load." );

       chatClient.display ( "Requesting ChatThingID..." );

String  imageURLName = "chat_images/ERNIE.GIF";

       values = new String [ ] { imageURLName, "0", "0" };

       return new ChatMessage [ ] {
         new ChatMessage (
           ChatMessage.CODE_REQUEST_THING,
           chatClient.getChatEntityID ( ),
           values ) };
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
