     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is
     // "com.orbs.open1.mpl.app.chat.command.ChatCommandLoad",
     // created 2000-01-16
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.app.chat.server.command;

     import java.awt.Point;
     import java.util.*;

     import com.orbs.open1.mpl.app.chat.*;
     import com.orbs.open1.mpl.app.chat.server.*;

     /*********************************************************************
     *
     * <P>
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   2000-01-23
     *********************************************************************/

     public final class  ChatCommandLoad implements ChatCommand
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private final ChatEntityID  chatEntityID;

     private final ChatModel     chatModel;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public  ChatCommandLoad (
       ChatEntityID  chatEntityID,
       ChatModel     chatModel )
     //////////////////////////////////////////////////////////////////////
     {
       this.chatEntityID = chatEntityID;

       this.chatModel    = chatModel;
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public ChatMessage  process ( ChatMessage  chatMessage )
     //////////////////////////////////////////////////////////////////////
     {
       ChatThingID [ ]  chatThingIDs = chatModel.getChatThingIDs ( );

       String [ ]  values = new String [ chatThingIDs.length * 4 ];

       for ( int  i = 0; i < chatThingIDs.length; i++ )
       {
         ChatThingID  chatThingID = chatThingIDs [ i ];

         Point  position = chatModel.getPosition ( chatThingID );

         String  imageURLName = chatModel.getImageURLName ( chatThingID );

         values [ 4 * i + 0 ] = chatThingID.toString ( );

         values [ 4 * i + 1 ] = imageURLName;

         values [ 4 * i + 2 ] = Integer.toString ( position.x );

         values [ 4 * i + 3 ] = Integer.toString ( position.y );
       }

       return new ChatMessage (
         ChatMessage.CODE_RESPONSE_LOAD,
         chatEntityID,
         values );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
