     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is "com.orbs.open1.mpl.net.http.WebServer",
     // created 1998-03-08.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.j1d1.net.http;

     import java.io.*;
     import java.net.*;
     import java.util.*;

     /*********************************************************************
     * <P>
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   2000-04-23
     *********************************************************************/

     public class  PrintServer implements Runnable {
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     private static final String  CRLF   = "\r\n";

     private static final String  SERVER = "FileServer/1.0";


     private final String        root;

     private final int           port;

     private       boolean       running;

     private       ServerSocket  serverSocket;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public static void  main ( String [ ]  args )
     //////////////////////////////////////////////////////////////////////
     {
System.out.println ( "PrintServer starting..." );

       String  root = "./";

       int     port = 80;

       new Thread ( new PrintServer ( root, port ) ).start ( );
     }

     public void  shutdown ( )
     //////////////////////////////////////////////////////////////////////
     {
       running = false;

       try { serverSocket.close ( ); } catch ( Exception  e ) { }
     }

     public  PrintServer ( String  root, int  port )
     //////////////////////////////////////////////////////////////////////
     {
       this.root = root;

       this.port = port;
     }

     public void  run ( )
     //////////////////////////////////////////////////////////////////////
     {
       try
       {
         serverSocket = new ServerSocket ( port );

         running = true;

         int  index = 0;

         while ( running )
         {
           Socket  clientSocket = serverSocket.accept ( );

           InputStream  in = clientSocket.getInputStream ( );

           int  c;

           while ( ( c = in.read ( ) ) > -1 )
           {
             System.out.print ( ( char ) c );
           }

           OutputStream  out = clientSocket.getOutputStream ( );

System.out.println ( "writing..." );

           out.write ( "HTTP/1.0 202\r\n".getBytes ( "US-ASCII" ) );

System.out.println ( "flushing..." );

           out.flush ( );

System.out.println ( "closing..." );

           out.close ( );

System.out.println ( "closing socket..." );

           clientSocket.close ( );

           index++;
         }
       }
       catch ( Exception  ex )
       {
         ex.printStackTrace ( );
       }

       try
       {
         serverSocket.close ( );
       }
       catch ( Exception  e )
       {
       }
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
