     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is "com.orbs.open1.mpl.util.queue.QueuePuller",
     // created 1998-11-23.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.j1d1.util.queue;

     import com.orbs.open1.mpl.role.Consumer;

     /*********************************************************************
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     * @version
     *   2000-04-28
     *********************************************************************/

     public class  QueuePuller implements Runnable
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     protected Queue     queue;
     protected Consumer  consumer;

     protected Thread    thread;
     protected boolean   running;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public  QueuePuller ( Queue  queue, Consumer  consumer )
     //////////////////////////////////////////////////////////////////////
     {
       this.queue    = queue;
       this.consumer = consumer;
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public void  run ( )
     //////////////////////////////////////////////////////////////////////
     {
       try
       {
         while ( running )
         {
           try
           {
             consumer.consume ( queue.pull ( ) );
           }
           catch ( InterruptedException  ex ) { }
         }
       }
       catch ( Exception  ex )
       {
         ex.printStackTrace ( );         
       }
     }

     public void  start ( )
     //////////////////////////////////////////////////////////////////////
     {
       stop ( );
       running = true;
       thread = new Thread ( this );
       thread.start ( );
     }

     public void  stop ( )
     //////////////////////////////////////////////////////////////////////
     {
       running = false;

// move this to an abort() method?
//       if ( thread != null ) thread.interrupt ( );
     }

     public boolean  append ( Object  o )
     //////////////////////////////////////////////////////////////////////
     {
       return queue.append ( o );
     }

     public Object  replace ( Object  o )
     //////////////////////////////////////////////////////////////////////
     {
       return queue.replace ( o );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
