     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is "com.orbs.open1.mpl.math.Point2D",
     // created 1998-05-29.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.math;

     import java.io.Serializable;

     /*********************************************************************
     * <P>
     * A 2D point in the standard Cartesian coordinate system.
     * This positive x-axis is to the right and the positive y-axis is up.
     * <P>
     * @version
     *   1998-05-29
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     *********************************************************************/

     class  Point2D implements Serializable
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     public double  x;
     public double  y;

     public  Point2D ( double  x, double  y ) { this.x = x; this.y = y; }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     /*********************************************************************
     * The angle, in radians, from this point to the target point.
     * Note that the direction of 0 radians is along the positive x-axis
     * and PI/2 radians is along the positive y-axis.
     *********************************************************************/
     public double  angleTo ( Point2D  target )
     //////////////////////////////////////////////////////////////////////
     {
       return Math.atan2 ( target.y - this.y, target.x - this.x );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }

