     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is "com.orbs.open1.mpl.net.news.Newsgroup",
     // created 1997-05-11.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.net.news;

     /*********************************************************************
     * <P>
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   1997-05-11
     *********************************************************************/

     public class  Newsgroup {
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     private String   group_name;
     private int      last_article;
     private int      first_article;
     private boolean  posting_allowed;
     private int      estimated_articles;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     /*********************************************************************
     * Note that the last_article comes before first_article in the
     * method signature.
     *********************************************************************/
     public  Newsgroup (
       String   group_name,
       int      last_article,
       int      first_article,
       boolean  posting_allowed ) {
     //////////////////////////////////////////////////////////////////////
       this.group_name      = group_name;
       this.last_article    = last_article;
       this.first_article   = first_article;
       this.posting_allowed = posting_allowed;
       if ( last_article > first_article ) {
         estimated_articles = last_article - first_article;
       }
     }

     public  Newsgroup (
       int      estimated_articles,
       int      first_article,
       int      last_article,
       String   group_name ) {
     //////////////////////////////////////////////////////////////////////
       this.estimated_articles = estimated_articles;
       this.first_article      = first_article;
       this.last_article       = last_article;
       this.group_name         = group_name;
       this.posting_allowed    = true;
     }

     public String   group_name         ( ) { return group_name        ; }
     public int      last_article       ( ) { return last_article      ; }
     public int      first_article      ( ) { return first_article     ; }
     public boolean  posting_allowed    ( ) { return posting_allowed   ; }
     public int      estimated_articles ( ) { return estimated_articles; }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
