     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     //
     // The Original Code is
     // "com.orbs.open1.mpl.util.filemap.FileMapEntrySet",
     // created 1999-04-03.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.util.filemap;

     import java.io.*;
     import java.util.*;

     /*********************************************************************
     * This Set is required for the AbstractMap implementation of
     * FileMap.
     *
     * @see
     *   FileMap
     * @see
     *   java.util.AbstractSet
     *
     * @version
     *   1999-04-03
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     *********************************************************************/

     public class  FileMapEntrySet extends AbstractSet
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private File  rootDirectory;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public  FileMapEntrySet ( File  rootDirectory )
     //////////////////////////////////////////////////////////////////////
     {
       this.rootDirectory = rootDirectory;
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public Iterator  iterator ( )
     //////////////////////////////////////////////////////////////////////
     {
       return new FileMapEntryIterator ( rootDirectory );
     }

     public int  size ( )
     //////////////////////////////////////////////////////////////////////
     {
       String [ ]  files = rootDirectory.list ( );

       if ( files == null ) return 0;

       return files.length;
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
