     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is "com.orbs.open1.mpl.util.jlex.Token",
     // created 1999-02-10.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.util.jlex;

     /*********************************************************************
     * Token data class for use with JLex.
     *
     * <B>Reference:</B>
     *
     * <P>
     *
     * "JLex: A Lexical Analyzer Generator for Java"<BR>
     * <A HREF="http://www.cs.princeton.edu/~appel/modern/java/JLex/">
     * http://www.cs.princeton.edu/~appel/modern/java/JLex/</A>
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     * @version
     *   1999-02-10
     *********************************************************************/

     public class  Token
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     /** The token type identifier number. */
     public int     id        = -1;

     public String  text      = null;

     /** Defaults to -1. */
     public int     line      = -1;

     /** Defaults to -1. */
     public int     charBegin = -1;

     /** Defaults to -1. */
     public int     charEnd   = -1;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public  Token (
       int     id,
       String  text,
       int     line,
       int     charBegin,
       int     charEnd )
     //////////////////////////////////////////////////////////////////////
     {
       this.id        = id;
       this.text      = text;
       this.line      = line;
       this.charBegin = charBegin;
       this.charEnd   = charEnd;
     }

     public  Token (
       int     id,
       String  text )
     //////////////////////////////////////////////////////////////////////
     {
       this.id   = id;
       this.text = text;
     }

     public  Token ( int  id )
     //////////////////////////////////////////////////////////////////////
     {
       this.id = id;
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public String  toString ( )
     //////////////////////////////////////////////////////////////////////
     {
       return
           "id        = " + id        + "\n"
         + "text      = " + text      + "\n"
         + "line      = " + line      + "\n"
         + "charBegin = " + charBegin + "\n"
         + "charEnd   = " + charEnd;
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
